#include <stdio.h>                      /* menuPile.c */

#include "modulePile.h"

int menu(void)
{
 int rep;
 int minRep = 0, maxRep = 5;

 do
 {
   printf("\n");
   printf("0. Sortie\n");
   printf("1. Afficher la pile\n");
   printf("2. Afficher le sommet\n");
   printf("3. Afficher la base\n");
   printf("4. Empiler un element\n");
   printf("5. Depiler un element\n");

   printf("Votre choix:");
   scanf("%d",&rep);
   if (rep < minRep || rep > maxRep) { printf("Erreur de saisie\n"); }

 } while (rep < minRep || rep > maxRep);

 printf("\n");
   
 return rep;
}

/**********************************************************************/
int main(void)
{
 pile p = creerPile();
  
 int rep;

 rep = menu();

 while (rep!=0)
 {
   switch (rep)
   {
    case 1: { afficherPile(p);
              printf("\n");
              break;
            }
    case 2: { if (estVidePile(p))
              {
               printf("Attention, pile vide!\n");
              }
              else { int sommet = sommetPile(p);
                     printf("Le sommet de la pile est :%d\n",sommet);
                   }
              break;
            }
    case 3: { if (estVidePile(p))
              {
               printf("Attention, pile vide!\n");
              }
              else { int base = basePile(p);
                     printf("La base de la pile est :%d\n",base);
                   }
              break;
            }
    case 4: { if (estPleinePile(p))
              {
               printf("Attention, pile pleine!\n");
              }
              else { int elem;
                     printf("Element a empiler?\n");
                     scanf("%d",&elem);
                     empilerPile(&p,elem);
                   }
              break;
            }
   default: { if (estVidePile(p))
              {
               printf("Attention, pile vide!\n");
              }
              else { depilerPile(&p); }
              break;
            }
   }

   rep = menu();
 } 

 printf("Sortie du programme\n");

 return 0;
}
